% ..  .
%   MATLAB. 2023
%Script 1.1
%   
clc; clear all; close all
%  
% 
U0=[1 .5];
% 
T=2;
%     
tmin=-T;
tmax=3/2*T;
% 
dt=.001;
%  
t=tmin:dt:tmax;
%   
fun=@(t) double(abs(t)<=T/2);
u1=U0(1)*fun(t);
u2=U0(2)*fun(t-T/2);
subplot(2,1,1)
plot(t,u1,t,u2)
xlim([tmin tmax])
umin=-.1;
umax=max(U0)+.1;
ylim([umin umax])
grid
str1=['U_0 = ',num2str(U0(1)),' '];
str2=['U_0 = ',num2str(U0(2)),' '];
legend(str1,str2)
title('  ')
xlabel('t, ')
ylabel('u_1(t), u_2(t), ')
%  MATLAB
u1=U0(1)*rectpuls(t,T);
u2=U0(2)*rectpuls(t-T/2,T);
subplot(2,1,2)
plot(t,u1,t,u2)
xlim([tmin tmax])
umin=-.1;
umax=max(U0(1),U0(2))+.1;
ylim([umin umax])
grid
xlabel('t, ')
ylabel('u_1(t), u_2(t), ')
str1=['U_0 = ',num2str(U0(1)),' '];
str2=['U_0 = ',num2str(U0(2)),' '];
legend(str1,str2)
title('  MATLAB')
%   
En=integral(@(t)fun(t).^2,-T/2,T/2);
%   
disp(' :')
disp('-------------------')
disp(' ')
for k=1:length(U0)
fprintf('%u- :\n',k)
E=U0(k)^2*En;
Pmax=U0(k)^2;
P=E/T;
PF=Pmax/P;
fprintf('- %f ;\n',U0(k))
fprintf('- %f ;\n',T)
fprintf('- %f ;\n',E)
fprintf('-  %f ;\n',Pmax)
fprintf('-  %f ;\n',P)
fprintf('-- %f (%f ).\n',PF,10*log10(PF))
disp(' ')
end