% ..  .
%   MATLAB. 2023
%Script 3.2
%     
clc; clear all; close all
%  
% 
U0=1;
% 
T=1;
%   
tmax=T;
%   
dt=.001;
%    
N_peaks=4;
%  
fmax=N_peaks/T;
%   
df=.001;
% 
%  
t=-tmax:dt:tmax;
%     MATLAB
u=U0*tripuls(t,T);
subplot(3,1,1)
plot(t,u)
ylim([-.1 U0+.1])
grid
xlabel('t, ')
ylabel('u(t), ')
str=['  , U_0 = ',num2str(U0),...
' ,  = ',num2str(T),' '];
title(str)
%  
f=-fmax:df:fmax;
%     
UF=integral(@(t)U0*tripuls(t,T).*cos(2*pi*f*t),-T/2,T/2,'ArrayValued',true);
subplot(3,1,2)
plot(f,UF)
ylim([min(UF)-.1 U0*T/2+.1])
grid
xlabel('f, ')
ylabel('U_F(f), /')
title('  ()')
%   
U=U0*T/2*sinc(f*T/2).^2;
subplot(3,1,3)
plot(f,U)
ylim([min(U)-.1 U0*T/2+.1])
grid
xlabel('f, ')
ylabel('U(f), /')
title('  ()')
%   
dU=max(abs(UF-U));
fprintf('  : %e /.\n',dU)