% ..  .
%   MATLAB. 2023
%Script 3.6
%      
% 
clc; clear all; close all
%  
% 
U0=1;
% ""
a=1;
% 
T=1;
%     
tmin=-.1/a;
tmax=1.2*T;
%   
dt=.001;
%  
fmax=4*a;
%   
df=.001;
% 
%  
t=tmin:dt:tmax;
% 
fun=@(t) exp(-a*t).*((t>=0) & (t<=T));
% 
u=U0*fun(t);
subplot(3,1,1)
plot(t,u)
ylim([-.1 U0+.1])
grid
xlabel('t, ')
ylabel('u(t), ')
str=[' , U_0 = ',num2str(U0),...
' , \alpha = ' ,num2str(a),' ^{-1}, T = ',num2str(T),' '];
title(str)
%  
f=0:df:fmax;
%     
UF=integral(@(t)U0*fun(t).*exp(-1i*2*pi*f*t),0,T,'ArrayValued',true);
A=U0./sqrt(a^2+(2*pi*f).^2);
subplot(3,1,2)
plot(f,2*abs(UF),f,2*A,'--')
ylim([min(abs(UF))-.1 2*U0/a+.1])
grid
xlabel('f, ')
ylabel('|U^+_F(f)|, /')
title('   ()')
subplot(3,1,3)
phi=-atan2(2*pi*f,a);
plot(f,angle(UF),f,phi,'--')
ylim([min(angle(UF))-.1 .1])
grid
xlabel('f, ')
ylabel('\phi^+_F(f), ')
title('   ()')
%   
U=U0./(a+1i*2*pi*f).*(1-exp(-(a+1i*2*pi*f)*T));
%   
dU=max(abs(UF-U));
fprintf('  : %e /.\n',dU)
figure
subplot(3,1,1)
plot(t,u)
ylim([-.1 U0+.1])
grid
xlabel('t, ')
ylabel('u(t), ')
str=[' , U_0 = ',num2str(U0),...
' , \alpha = ' ,num2str(a),' ^{-1}, T = ',num2str(T),' '];
title(str)
subplot(3,1,2)
plot(f,2*abs(U),f,2*A,'--')
ylim([min(abs(U))-.1 2*U0/a+.1])
grid
xlabel('f, ')
ylabel('|U^+(f)|, /')
title('   ()')
subplot(3,1,3)
plot(f,angle(U),f,phi,'--')
ylim([min(angle(U))-.1 .1])
grid
xlabel('f, ')
ylabel('\phi^+(f), ')
title('   ()')