% ..  .
%   MATLAB. 2023
%Script 4.8
%     
%  
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
%     
tmin=-T; tmax=T;
%   
dt=.01;
%  
t=tmin:dt:tmax;
%    (  )
vF=[2/T 4/T 6/T 8/T];
% 
nF=length(vF);
%     
for k=1:nF
F=vF(k);
y=integral(@(f)U0*T/2*sinc(f*T/2).^2.*cos(2*pi*f*t),...
-F,F,'ArrayValued',true);
ymax=1.1*U0;
ymin=min(y)-.1;
subplot(nF/2,nF/2,k)
plot(t,y,t,U0*tripuls(t,T),'b--')
grid
xlim([tmin tmax])
ylim([ymin ymax]) 
xlabel('t, ')
ylabel('y(t), ')
x0=.2*T;
y0=.9*U0;
str=['F_c = ',num2str(F),' '];
text(x0,y0,str)
if k==1
title(['    , U_0 = ',...
num2str(U0),' , T = ',num2str(T),' '],...
'Units','normalized','Position',[1.155 1.03 0])    
end
end