% ..  .
%   MATLAB. 2023
%Script 5.4
%     
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
% 
dt=.001;
%     
tmin=-1.1*T;
tmax=1.1*T;
%  
t=tmin:dt:tmax;
%    
%  
u=U0*rectpuls(t,T).*cos(pi/T*t);
%  
subplot(3,1,1)
plot(t,u)
grid
ymin=-.1;
ymax=1.1*U0;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)  U_0 = ',num2str(U0),...
' , T = ',num2str(T),' ']);   
%    
%    
[rx,lags]=xcorr(u);
tau=lags*dt;
rc=rx*dt;
% 
subplot(3,1,2)
plot(tau,rc)
grid
xlim([tmin tmax])
ymax=1.1*U0^2*T/2;
ylim([ymin ymax])
xlabel('t, ')
ylabel('r(\tau), ')
legend('')
%   
r=U0^2*T/2*((1-abs(tau)/T)...
.*cos(pi/T*tau)+1/pi*sin(pi/T*abs(tau)))...
.*rectpuls(tau,2*T);
% 
subplot(3,1,3)
plot(tau,r)
grid
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('r(\tau), ')
legend('')
%   
dr=max(abs(rc-r));
fprintf('  : %e .\n',dr)