% ..  .
%   MATLAB. 2023
%Script 6.10
%    
% -  ""-
clear all; close all; clc
%  
%     
umax=1; 
wmax=umax;
%  
u=-umax:.0001:umax;
%    
nu=length(u);
%   
vA=[87.56 10 1];
% 
nA=length(vA);
%  
y=zeros(nA,nu);
str=cell(1,nA);
%  
for k=1:nA
A=vA(k);
str{k}=['A = ',num2str(A)];
%     
% -
c_A=@(u) wmax*sign(u)*A.*abs(u)./umax./(1+log(A))...
        .*(abs(u)<=umax/A)...
        +wmax*sign(u).*(1+log(A*abs(u)./umax))./(1+log(A))...
        .*(abs(u)>umax/A); 
%  
y(k,:)=c_A(u);
end
%   
subplot(1,2,1)
plot(u,y)
grid
set(gca,'YMinorTick','on')
xlabel('u, ')
ylabel('w, ')
legend(str,'Location','SouthEast')
str_t1=' ';
str_t2='  -';
title({str_t1;str_t2}) 
%   ""
vmu=[255 10 0];
% 
nmu=length(vmu);
%  
y=zeros(nmu,nu);
str=cell(1,nmu);
%  
for k=1:nmu
mu=vmu(k);
str{k}=['\mu = ',num2str(mu)];
if mu==0
mu=10^-10;    
end
%     
% ""-
c_mu=@(u) wmax*sign(u).*log(1+mu*abs(u)/umax)./log(1+mu);
%  
y(k,:)=c_mu(u);
end
%   
subplot(1,2,2)
plot(u,y)
grid
set(gca,'YMinorTick','on')
xlabel('u, ')
ylabel('w, ')
legend(str,'Location','SouthEast')
str_t1=' ';
str_t2='  \mu-';
title({str_t1;str_t2})
