% ..  .
%   MATLAB. 2023
%Script 6.11
%     
%    A-  ""-
%     
clear all; close all; clc
%  
%   
umax=1;
%  
vm=[5,6,7,8];
% 
nm=length(vm);
%     v ()
vmin_dB=-60; vmax_dB=0;
%    
nv=101;
% 
dv=(vmax_dB-vmin_dB)/(nv-1);
%  v ()
v_db=vmin_dB:dv:vmax_dB;
%  v
v=10.^(v_db/20);
%  
s_u=(v*umax).^2;
%  ""
lambda=sqrt(2./s_u);
%     
fp=@(x) .5*lambda.*exp(-lambda.*abs(x));
%  
S_A=zeros(nm,nv);
S_mu=zeros(nm,nv);
str= cell(1,nm);
S_max=zeros(1,nm);
v0_db=zeros(1,nm);
P=zeros(1,nm);
%  
A=87.56;
mu=255;
%  S   m
for im=1:nm
% 
m=vm(im); 
str{im}=['{\itm} = ',num2str(m)];
K=2^m;
du=2*umax/K;
wmax=(K-1)*du/2;
%      
% -
c_A=@(u) wmax*sign(u).*A/umax./(1+log(A))...
        .*(0<=abs(u) & abs(u)<=umax/A)...
        +wmax*sign(u)./((1+log(A))*abs(u))...
        .*(umax/A<=abs(u) & abs(u)<=umax);
%       
s_q=wmax^2/(3*K^2)...
    *2*integral(@(x) fp(x)./c_A(x).^2,0,umax,'ArrayValued',true);
%    
s_r=2*integral(@(x)(wmax-x).^2.*fp(x),umax,inf,'ArrayValued',true);
%    
s_e=s_q+s_r;
%      ()
S_A(im,:)=10*log10(s_u./s_e);
%      
% ""-
c_mu=@(u) wmax*sign(u).*mu/umax./(log(1+mu)*(1+mu*abs(u)/umax))...
          .*(0<=abs(u) & abs(u)<=umax);
%       
s_q=wmax^2/(3*K^2)...
    *2*integral(@(x) fp(x)./c_mu(x).^2,0,umax,'ArrayValued',true);
%    
s_r=2*integral(@(x)(wmax-x).^2.*fp(x),umax,inf,'ArrayValued',true);
%    
s_e=s_q+s_r;
%      ()
S_mu(im,:)=10*log10(s_u./s_e);
end
%   -
plot(v_db,S_A)
grid
ylabel('S, ')
xlabel('\nu, ')
st_1='  S   \nu    m';
st_2='   A-     ';
title({st_1;st_2}) 
legend(str)
ylim([0 40])
%     
hold on
for im=1:nm
[S_max(im),I_max]=max(S_A(im,:));
v0_db(im)=vmin_dB+(I_max-1)*dv;
v0=10^(v0_db(im)/20);
lm0=sqrt(2)/(v0*umax);
fp_im=@(x) .5*lm0.*exp(-lm0.*abs(x));
P(im)=2*integral(@(x) fp_im(x),umax,inf);
line([v0_db(im) v0_db(im)],[0 S_max(im)],'LineStyle','--')
plot(v0_db(im),S_max(im),'r.')
plot(v0_db(im),0,'r.')
end
% 
disp('    ')
disp('    A-')
disp('     ')
disp('---------------------------------')
disp('m  Smax,    v0,        P')
for im=1:nm
A=[vm(im),S_max(im),v0_db(im),P(im)];
fprintf('%i   %2.2f     %2.2f    %2.2e\n',A);
end
disp('---------------------------------')
%   ""-
figure
plot(v_db,S_mu)
grid
ylabel('S, ')
xlabel('\nu, ')
st_1='  S   \nu    m';
st_2='   \mu-     ';
title({st_1;st_2}) 
legend(str)
ylim([0 40])
%     
hold on
for im=1:nm
[S_max(im),I_max]=max(S_mu(im,:));
v0_db(im)=vmin_dB+(I_max-1)*dv;
v0=10^(v0_db(im)/20);
lm0=sqrt(2)/(v0*umax);
fp_im=@(x) .5*lm0.*exp(-lm0.*abs(x));
P(im)=2*integral(@(x) fp_im(x),umax,inf);
line([v0_db(im) v0_db(im)],[0 S_max(im)],'LineStyle','--')
plot(v0_db(im),S_max(im),'r.')
plot(v0_db(im),0,'r.')
end
%  
disp('  ')
disp('    ')
disp('    ""-')
disp('     ')
disp('---------------------------------')
disp('m  Smax,    v0,        P')
for im=1:nm
A=[vm(im),S_max(im),v0_db(im),P(im)];
fprintf('%i   %2.2f     %2.2f    %2.2e\n',A);
end
disp('---------------------------------')