% ..  .
%   MATLAB. 2023
%Script 7.11
% - 
%  
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
% 
f0=10;
%  
vtau=[.1 .2 .4];
% 
ntau=length(vtau);
%     
tmi=0; tma=2*T;
%   
dt=.01/f0;
%  
t=0:dt:tma;
%    
%  
fun_y=@(t,tau) (1-exp(-t/tau)).*heaviside(t)...
              -(1-exp(-(t-T)/tau)).*heaviside(t-T);
%    
for k=1:ntau
tau=vtau(k);
yl=U0*fun_y(t,tau);
y=yl.*cos(2*pi*f0*t);
%     
subplot(ntau,1,k)
plot(t,y,t,yl,'--')
grid
xlim([tmi tma])
ymi=-1.1*U0; yma=1.4*U0;
ylim([ymi yma])
xlabel('t, ')
ylabel('y(t), ')
str=['      \tau_c = ',...
    num2str(tau),' '];
title(str)
end