% ..  .
%   MATLAB. 2023
%Script 2.1
%     
clc; clear all; close all
%  
% 
U0=1;
%   
T=1;
%  ( )
q=2;
%  ()
NT=5;
%   
dt=.001;
%    
N_petal=4.5;
%   
df=.01;
% 
% 
T0=q*T;
%   
tmax=(NT-1)/2*T0+q*T/2;
%  
t=-tmax:dt:tmax;
%  
d=-(NT-1)/2*T0:T0:(NT-1)/2*T0;
%  
u0=U0*pulstran(t,d,'rectpuls',T);
%     
subplot(2,1,1)
ymi=-0.1; yma=U0+.1;
plot(t,u0)
grid
ylim([ymi yma])
set(gca,'XMinorTick','on')
xlabel('t, ')
ylabel('u_0(t), ')
title(['  , q = ',num2str(q)])
%      
fmax=N_petal/T;
fc=0:1/T0:fmax;
fk=[-fc(end:-1:2),fc];
%   
nc=length(fc)-1;
c0=U0/q;
k=1:nc; c=U0/q*sinc(k/q);
ck=[c(end:-1:1),c0,c];
%     
subplot(2,1,2)
stem(fk,ck,'fill','MarkerSize',4)
grid
%    "" 
f=-fmax:df:fmax;
y=U0/q*sinc(f*T);
hold on
% "" 
plot(f,y,':')
xlabel('f, ')
ylabel('c_k, ')
title(' ')
%  
disp(' :')
disp('-----------------------------')
fprintf('-  %f ;\n',U0)
fprintf('-  %f ;\n',T)
fprintf('-  %f;\n',q)
fprintf('-  %f ;\n',c0)
disp('  :')
for k=1:nc
fprintf('%u-: %9.6f ;\n',k,c(k))
end
%        
% 
cc=[c0,2*c];
ak=abs(cc);
pk=-angle(cc);
% ""
f=0:df:fmax;
y=2*U0/q*sinc(f*T);
figure
subplot(2,1,1)
%     ""
stem(fc,ak,'fill','MarkerSize',4)
grid
hold on
plot(f,abs(y),':')
xlabel('f, ')
ylabel('|c_k^+|, ')
title([' , q = ',num2str(q)])
subplot(2,1,2)
%     ""
stem(fc,pk,'fill','MarkerSize',4)
grid
hold on
plot(f,-angle(y),':')
xlabel('f, ')
ylabel('\phi_k, ')
title(' ')