% ..  .
%   MATLAB. 2023
%Script 3.5
%    
clc; clear all; close all
%  
% 
U0=1;
% ""
a=1;
%   
tmax=3/a;
%   
dt=.001;
%  
fmax=a;
%   
df=.001;
% 
%  
t=-tmax:dt:tmax;
% 
fun=@(t) exp(-(a*t).^2);
% 
u=U0*fun(t);
subplot(3,1,1)
plot(t,u)
ylim([-.1 U0+.1])
grid
xlabel('t, ')
ylabel('u(t), ')
str=[' , U_0 = ',num2str(U0),...
' , \alpha = ',num2str(a),' ^{-1}'];
title(str)
%  
f=-fmax:df:fmax;
%     
UF=integral(@(t)U0*fun(t).*cos(2*pi*f*t),-inf,inf,'ArrayValued',true);
subplot(3,1,2)
plot(f,UF)
ylim([min(UF)-.1 U0*sqrt(pi)/a+.1])
grid
xlabel('f, ')
ylabel('U_F(f), /')
title('  ()')
%   
U=U0*sqrt(pi)/a*exp(-(pi*f/a).^2);
subplot(3,1,3)
plot(f,U)
ylim([min(U)-.1 U0*sqrt(pi)/a+.1])
grid
xlabel('f, ')
ylabel('U(f), /')
title('  ()')
%   
dU=max(abs(UF-U));
fprintf('  : %e /.\n',dU)