% ..  .
%   MATLAB. 2023
%Script 5.1
%    
clc; clear all; close all
%  
% 
U0=1;
% 
T=1;
%     
tmin=-1.1*T;
tmax=1.1*T;
% 
dt=.001;
%  
t=tmin:dt:tmax;
%    
% 
u=U0*rectpuls(t-T/2,T);
%  
subplot(3,1,1)
plot(t,u)
grid
ymin=-.1;
ymax=1.1*U0;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)  U_0 = ',num2str(U0),...
' , T = ',num2str(T),' ']);   
%    
%    
[rx,lags]=xcorr(u);
tau=lags*dt;
rc=rx*dt;
% 
subplot(3,1,2)
plot(tau,rc)
grid
xlim([tmin tmax])
ymax=1.1*U0^2*T;
ylim([ymin ymax])
xlabel('t, ')
ylabel('r(\tau), ')
legend('')
%   
r=U0^2*tripuls(tau,2*T);
% 
subplot(3,1,3)
plot(tau,r)
grid
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('r(\tau), ')
legend('')
%   
dr=max(abs(rc-r));
fprintf('  : %e .\n',dr)