% ..  .
%   MATLAB. 2023
%Script 5.2
%    
clc; clear all; close all
%  
% 
U0=1;
% ""
a=1;
%     
tmin=-5/a;
tmax=5/a;
% 
dt=.00001;
%  
t=tmin:dt:tmax;
%    
% 
u=U0*exp(-a*t).*(t>=0);
%  
subplot(3,1,1)
plot(t,u)
grid
ymin=-.1;
ymax=1.1*U0;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)  U_0 = ',num2str(U0),...
' , \alpha = ',num2str(a),' ^{-1}']);   
%    
%    
[rx,lags]=xcorr(u);
tau=lags*dt;
rc=rx*dt;
% 
subplot(3,1,2)
plot(tau,rc)
grid
xlim([tmin tmax])
ymax=.6*U0^2/a;
ylim([ymin ymax])
xlabel('t, ')
ylabel('r(\tau), ')
legend('')
%   
r=.5*U0^2/a*exp(-a*abs(tau));
% 
subplot(3,1,3)
plot(tau,r)
grid
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('r(\tau), ')
legend('')
%   
dr=max(abs(rc-r));
fprintf('  : %e .\n',dr)