% ..  .
%   MATLAB. 2023
%Script 6.14
%     
%    
%     
clear all; close all; clc
%  
%   
umax=1;
%  
m=8;
%     v ()
vmin_dB=-60; vmax_dB=0;
%    
nv=101;
% 
dv=(vmax_dB-vmin_dB)/(nv-1);
%  v ()
v_db=vmin_dB:dv:vmax_dB;
%  v
v=10.^(v_db/20);
%  
s_u=(v*umax).^2;
%     
fp=@(x) 1./sqrt(2*pi*s_u).*exp(-x.^2./(2*s_u));
%  
A=87.56;
mu=255;
%  S
% 
K=2^m;
du=2*umax/K;
wmax=(K-1)*du/2;
%   -
c_A=@(u) wmax*sign(u).*A/umax./(1+log(A))...
        .*(0<=abs(u) & abs(u)<=umax/A)...
        +wmax*sign(u)./((1+log(A))*abs(u))...
        .*(umax/A<=abs(u) & abs(u)<=umax);
%       
s_q_A=wmax^2/(3*K^2)...
    *2*integral(@(x) fp(x)./c_A(x).^2,0,umax,'ArrayValued',true);
%   ""-
c_mu=@(u) wmax*sign(u).*mu/umax./(log(1+mu)*(1+mu*abs(u)/umax))...
          .*(0<=abs(u) & abs(u)<=umax);
%       
s_q_mu=wmax^2/(3*K^2)...
    *2*integral(@(x) fp(x)./c_mu(x).^2,0,umax,'ArrayValued',true);
%    
q=@(u) (sign(u)*du.*(fix(abs(u)/du)+.5)).*(abs(u)<umax)...
      +sign(u)*wmax.*(abs(u)>=umax);
%       
s_q=2*integral(@(x)(q(x)-x).^2.*fp(x),0,umax,'ArrayValued',true);
%    
s_r=2*integral(@(x)(wmax-x).^2.*fp(x),umax,inf,'ArrayValued',true);
%    
s_e_A=s_q_A+s_r;
s_e_mu=s_q_mu+s_r;
s_e=s_q+s_r;
%      ()
S_A=10*log10(s_u./s_e_A);
S_mu=10*log10(s_u./s_e_mu);
S=10*log10(s_u./s_e);
% 
plot(v_db,S_A,v_db,S_mu,v_db,S)
grid
ylabel('S, ')
xlabel('\nu, ')
str_t1=['  S   \nu  m = ',num2str(m)];
str_t2='     ';
title({str_t1;str_t2}) 
legend('  A-','  \mu-',...
       ' ','Location','SouthEast')